def is_guarded(warehouse, guard):
    for w in warehouse:
        if abs(w - guard[0]) <= guard[1]:
            return True
    return False

def find_guarded_warehouses(n, m, guards):
    guarded = set()
    for i in range(1, n+1):
        for guard in guards:
            if is_guarded([i], guard):
                guarded.add(i)
                break
    return guarded

n = 5
m = 4
guards = [(2, 1), (4, 2), (5, 3)]

guarded_warehouses = find_guarded_warehouses(n, m, guards)
print("Guarded warehouses:", guarded_warehouses)